//==========================================================================
//
//      io/serial/nios2/altera_bd/altera_bd_serial.h
//
//      NIOS2 ALTERA_BD Serial I/O definitions.
//
//==========================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//==========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    Hao Tseng base on ecos serial driver of MIPS IDT79s334a
//                                 and Altera ecos serial driver
// Contributors: 
// Date:         2006-02-28
// Purpose:      NIOS2 Altera_BD serial device driver definitions.
// Description:  
//####DESCRIPTIONEND####
//==========================================================================

// UART register address offset
#define NIOS2_UART_RX_REG_OFFSET        (0x0*4)
#define NIOS2_UART_TX_REG_OFFSET        (0x1*4)
#define NIOS2_UART_STATUS_REG_OFFSET    (0x2*4)
#define NIOS2_UART_CONTROL_REG_OFFSET   (0x3*4)
#define NIOS2_UART_DIVISOR_REG_OFFSET   (0x4*4)


// UART Status register bit definition
#define UART_STATUS_BIT_PE          0x1
#define UART_STATUS_BIT_FE          0x2
#define UART_STATUS_BIT_BRK         0x4
#define UART_STATUS_BIT_ROE         0x8
#define UART_STATUS_BIT_TOE         0x10
#define UART_STATUS_BIT_TMT         0x20
#define UART_STATUS_BIT_TRDY        0x40
#define UART_STATUS_BIT_RRDY        0x80
#define UART_STATUS_BIT_E           0x100
#define UART_STATUS_BIT_DCTS        0x400
#define UART_STATUS_BIT_CTS         0x800
#define UART_STATUS_BIT_EOP         0x1000

// UART Control register bit definition
#define UART_CTRL_BIT_IPE           0x1
#define UART_CTRL_BIT_IFE           0x2
#define UART_CTRL_BIT_IBRK          0x4
#define UART_CTRL_BIT_IROE          0x8
#define UART_CTRL_BIT_ITOE          0x10
#define UART_CTRL_BIT_ITMT          0x20
#define UART_CTRL_BIT_ITRDY         0x40
#define UART_CTRL_BIT_IRRDY         0x80
#define UART_CTRL_BIT_IE            0x100
#define UART_CTRL_BIT_IRBK          0x200
#define UART_CTRL_BIT_IDCTS         0x400
#define UART_CTRL_BIT_IRTS          0x800
#define UART_CTRL_BIT_IEOP          0x1000

static unsigned int select_baud[] = {
    0,        // Unused
    50,       // 50
    75,       // 75
    110,      // 110
    134,      // 134.5
    150,      // 150
    200,      // 200
    300,      // 300
    600,      // 600
    1200,     // 1200
    1800,     // 1800
    2400,     // 2400
    3600,     // 3600
    4800,     // 4800
    7200,     // 7200
    9600,     // 9600
    14400,    // 14400
    19200,    // 19200
    38400,    // 38400
    57600,    // 57600
    115200,   // 115200
    230400,   // 230400
};

// EOF altera_bd_serial.h
