//===========================================================================
//
//      hal_priv.c
//
//      NIOS II Architecture Altera_Cyclone_Board-specific private variables
//
//===========================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//===========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    Hao Tseng
// Contributors: 
// Date:         2003/12/08
// Purpose:      private vars for NIOS II processor.
//              
//####DESCRIPTIONEND####
//
//===========================================================================


#include <cyg/hal/hal_intr.h>
#include <cyg/hal/hal_arch.h>
#include <cyg/hal/hal_diag.h>
#include CYGBLD_HAL_PLATFORM_H
#include <cyg/hal/hal_if.h>


// ------------------------------------------------------------------------
// Board specific startups.

extern void hal_platform_init( void );

void hal_platform_init( void )
{
#ifdef CYGSEM_HAL_VIRTUAL_VECTOR_SUPPORT
    hal_if_init();  // Initialize GDB[ROM]/eCos interfaces
#endif    
}

#ifdef CYGSEM_HAL_VIRTUAL_VECTOR_DIAG
  #define HAL_NIOS2_LOW_LEVEL_DEBUG_WRITE_CHAR(_x_)    HAL_DIAG_WRITE_CHAR(_x_)
#else
  #define HAL_NIOS2_LOW_LEVEL_DEBUG_WRITE_CHAR(_x_)    HAL_DIAG_LV_WRITE_CHAR(_x_)  
#endif

 
void _DUMP_BYTE(unsigned char cc)
{
    if((cc >> 4) >= 10)
        HAL_NIOS2_LOW_LEVEL_DEBUG_WRITE_CHAR('a' + (cc >> 4) - 10);
    else
        HAL_NIOS2_LOW_LEVEL_DEBUG_WRITE_CHAR('0' + (cc >> 4));        
    
    if((cc & 0x0f) >= 10)
        HAL_NIOS2_LOW_LEVEL_DEBUG_WRITE_CHAR('a' + (cc & 0x0f) - 10);
    else
        HAL_NIOS2_LOW_LEVEL_DEBUG_WRITE_CHAR('0' + (cc & 0x0f));
}    
    
void _DUMP_UINT16(cyg_uint16 uu)
{
    _DUMP_BYTE(uu >> 8);    
    _DUMP_BYTE(uu & 0xff);    
}

void _DUMP_UINT32(cyg_uint32 uu)
{
    _DUMP_UINT16(uu >> 16);    
    _DUMP_UINT16(uu & 0xffff);    
}

void _DUMP_CHAR(unsigned char cc)
{
    if( cc == '\n' )
    {
        HAL_NIOS2_LOW_LEVEL_DEBUG_WRITE_CHAR('\r');        
    }

    HAL_NIOS2_LOW_LEVEL_DEBUG_WRITE_CHAR(cc);
}

void _DUMP_STRING(unsigned char *str)
{
    while(*str) _DUMP_CHAR(*str++);
}

void _DUMP_RETURN(void)
{
    HAL_NIOS2_LOW_LEVEL_DEBUG_WRITE_CHAR('\r');
    HAL_NIOS2_LOW_LEVEL_DEBUG_WRITE_CHAR('\n');    
}

void _DUMP_REGS(HAL_SavedRegisters *Regs)
{
}

void _DUMP_MEM(cyg_uint32 addr, cyg_uint32 len)
{
    cyg_uint32 i;
    _DUMP_STRING("\nMem:0x");
    _DUMP_UINT32(addr);
    for(i=0;i<len;i++){
        if((i%8)==0)
            _DUMP_RETURN();
        _DUMP_CHAR(' ');
        _DUMP_UINT32(*((cyg_uint32 *)(addr+i*4)));
    }
    _DUMP_RETURN();
        
}
// EOF hal_priv.c

