#ifndef CYGONCE_HAL_ARCH_INC
#define CYGONCE_HAL_ARCH_INC
//=============================================================================
//
//	arch.inc
//
//	NIOS II assembler header file
//
//=============================================================================
//###ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//###ECOSGPLCOPYRIGHTEND####
//=============================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s): 	Hao Tseng
// Contributors:	
// Date:	
// Purpose:	Architecture definitions.
// Description:	This file contains various definitions and macros that are
//              useful for writing assembly code for the NIOS II CPU family.
// Usage:
//		#include <cyg/hal/arch.inc>
//		...
//		
//
//####DESCRIPTIONEND####
//
//=============================================================================

//-----------------------------------------------------------------------------
// Size of HAL_SavedRegisters for NIOS II 
#define SAVED_REGS_SIZE (38*4)

//--------------------------------------------------------------------------
// Execption vectors definition

// Vector definition 
#define CYGNUM_HAL_VECTOR_0                     0
#define CYGNUM_HAL_VECTOR_1                     1
#define CYGNUM_HAL_VECTOR_2                     2
#define CYGNUM_HAL_VECTOR_3                     3
#define CYGNUM_HAL_VECTOR_4                     4
#define CYGNUM_HAL_VECTOR_5                     5
#define CYGNUM_HAL_VECTOR_6                     6
#define CYGNUM_HAL_VECTOR_7                     7
#define CYGNUM_HAL_VECTOR_8                     8
#define CYGNUM_HAL_VECTOR_9                     9
#define CYGNUM_HAL_VECTOR_10                    10
#define CYGNUM_HAL_VECTOR_11                    11
#define CYGNUM_HAL_VECTOR_12                    12
#define CYGNUM_HAL_VECTOR_13                    13
#define CYGNUM_HAL_VECTOR_14                    14
#define CYGNUM_HAL_VECTOR_15                    15
#define CYGNUM_HAL_VECTOR_16                    16
#define CYGNUM_HAL_VECTOR_17                    17
#define CYGNUM_HAL_VECTOR_18                    18
#define CYGNUM_HAL_VECTOR_19                    19
#define CYGNUM_HAL_VECTOR_20                    20
#define CYGNUM_HAL_VECTOR_21                    21
#define CYGNUM_HAL_VECTOR_22                    22
#define CYGNUM_HAL_VECTOR_23                    23
#define CYGNUM_HAL_VECTOR_24                    24
#define CYGNUM_HAL_VECTOR_25                    25
#define CYGNUM_HAL_VECTOR_26                    26
#define CYGNUM_HAL_VECTOR_27                    27
#define CYGNUM_HAL_VECTOR_28                    28
#define CYGNUM_HAL_VECTOR_29                    29
#define CYGNUM_HAL_VECTOR_30                    30
#define CYGNUM_HAL_VECTOR_31                    31

#define CYGNUM_HAL_VECTOR_BREAK                 32
#define CYGNUM_HAL_VECTOR_TRAP                  33
#define CYGNUM_HAL_VECTOR_UNKNOWN_INST          34

#define CYGNUM_HAL_VSR_MIN              CYGNUM_HAL_VECTOR_0
#define CYGNUM_HAL_VSR_MAX              CYGNUM_HAL_VECTOR_TRAP
#define CYGNUM_HAL_VSR_COUNT            (CYGNUM_HAL_VSR_MAX - CYGNUM_HAL_VSR_MIN +1)


// Exception & interrupt count 
//#define CYGNUM_HAL_EXCEPTION_TRAP      CYGNUM_HAL_VECTOR_TRAP
 
#define CYGNUM_HAL_EXCEPTION_MIN       CYGNUM_HAL_VECTOR_BREAK
#define CYGNUM_HAL_EXCEPTION_MAX       CYGNUM_HAL_VECTOR_UNKNOWN_INST
#define CYGNUM_HAL_EXCEPTION_COUNT     (CYGNUM_HAL_EXCEPTION_MAX - CYGNUM_HAL_EXCEPTION_MIN + 1)

#define CYGNUM_HAL_ISR_MIN             CYGNUM_HAL_VECTOR_0
#define CYGNUM_HAL_ISR_MAX             CYGNUM_HAL_VECTOR_31
#define CYGNUM_HAL_ISR_COUNT           (CYGNUM_HAL_ISR_MAX - CYGNUM_HAL_ISR_MIN +1 )


#endif // ifndef CYGONCE_HAL_ARCH_INC
//# end of arch.inc

